<?php

require_once plugin_dir_path( __FILE__ ) . 'vendor/Twig-1.35.4/lib/Twig/Autoloader.php';
Twig_Autoloader::register();

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

if ( ! class_exists( 'EMSG_SignatureGenerator_Plugin' ) ) :

class EMSG_SignatureGenerator_Plugin {

  private static function convert($type, $metadata) {
    $result = array();
    foreach ($metadata as $key => $value) {
      $newkey = str_ireplace($type, '', $key);
  	  $result[$newkey] = $value[0];
  		if (strpos($newkey, 'phone mobile') !== false) {
  			$result[$newkey . '_url'] = $newkey;
  		}
  	}

    return $result;
  }

  private static function shorturl($msg) {
    return $msg;
  }

  public static function execute($id) {

    $meta = get_post_meta($id, '', false);
    $mail = $meta['_emsg_person_mail'][0];
    $orgId = $meta['_emsg_person_company'][0];

    // Gets redirecting service
    $r = EMSG_Company_Plugin::getRedirectService($orgId);

    // Removes prefixes to make it simple to understand
    $person = self::convert("_emsg_person_", $meta);
    $org = self::convert("_emsg_company_", get_post_meta($orgId, '', false));
    $key = $org['mail'];

    $twitterHref = "https://twitter.com/";
    $linkedinHref = "http://us.linkedin.com/in/";
    $facebookHref = "https://www.facebook.com/";

    $mt = self::shorturl($mail);                      // mail tracker
    $ot = self::shorturl($key);                       // org tracker
    $t = $ot . "/" . $mt;

    $person["twitterHref"]  = "";
    $person["linkedinHref"]  = "";
    $person["facebookHref"]  = "";

    if (array_key_exists('twitterId', $person)) {
      $person["twitterHref"]  = $r . "r-so-tw/" . $t;      // Your social accounts
    }
    if (array_key_exists('linkedinId', $person)) {
      $person["linkedinHref"] = $r . "r-so-li/" . $t;      // are strictly personal
    }
    if (array_key_exists('facebookId', $person)) {
      $person["facebookHref"] = $r . "r-so-fa/" . $t;      // No share with teams
    }
    $person["photoHref"]    = $r . "r-h-ph/" . $t;        // You may have one photo
    $person["photoSrc"]     = $r . "r-i-ph/" . $t;        // by team
    $org["logoHref"]        = $r . "r-h-lo/" . $ot . "/" . $mt;
    $org["logoSrc"]         = $r . "r-i-lo/" . $ot . "/" . $mt;
    $org["websiteHref"]     = $r . "r-h-we/" . $ot . "/" . $mt;
    $org["bannerHref"]      = $r . "r-h-ba/" . $ot . "/" . $mt;
    $org["bannerSrc"]       = $r . "r-i-ba/" . $ot . "/" . $mt;

    $person["photo"] = $person["photoSrc"];
    $person["twitter"] = $person["twitterHref"];
    $person["linkedin"] = $person["linkedinHref"];
    $person["facebook"] = $person["facebookHref"];
    $org["logo"] = $org["logoSrc"];

  	$loader = new Twig_Loader_Filesystem(plugin_dir_path( __FILE__ ) . '../assets');
  	$twig = new Twig_Environment($loader);
    return $twig->render('Template-Configuration.php', ['person' => $person, 'org' => $org]);

  }
}

endif;

new EMSG_SignatureGenerator_Plugin();
